#ifndef POINTSET_H
#define POINTSET_H

#include "point.h"

#include <QString>

class PointSet
{
private:
    Point *_points; // an array of all the points
    int _size;
    int _ref;


public:
    static PointSet* generateDefault();
    static PointSet* generate(int size);
    static PointSet* load(const QString &fname, QString **error);

    Point* points() { return _points; } // returns an array of points
    Point* sort(); // returns the head of a linked list of points
    int size() { return _size; }

    void colorize();

    void ref();
    void unref();

protected:
    PointSet();
    virtual ~PointSet();

    static Point*    sort(Point *P, unsigned long n);

};

#endif // POINTSET_H
